package com.sbh.background_locations.adapters

import android.util.Log
import org.json.JSONObject

class SBHFirebaseConfig() {
    var appName: String? = null
    var databaseUrl: String? = null
    var apiKey: String? = null
    var applicationId: String? = null
    var databaseRefPaths: List<SBHDatabaseRefPath> = emptyList()
    var email: String? = null
    var password: String? = null

    constructor(appName: String, databaseUrl: String, apiKey: String, applicationId: String,
                databaseRefPaths: List<SBHDatabaseRefPath>, email: String, password: String) : this() {
        this.appName = appName
        this.databaseUrl = databaseUrl
        this.apiKey = apiKey
        this.applicationId = applicationId
        this.databaseRefPaths = databaseRefPaths
        this.email = email
        this.password = password
    }

    companion object {
        fun fromJson(json: JSONObject): SBHFirebaseConfig {
            Log.d("SBHFirebaseConfig", json.toString())
            return SBHFirebaseConfig(
                    json.getString("app_name"),
                    json.getString("database_url"),
                    json.getString("api_key"),
                    json.getString("application_id"),
                    Array(json.getJSONArray("database_ref_paths").length()) {
                        Log.d("SBHFirebaseConfig", json.getJSONArray("database_ref_paths")[it].toString())
                        SBHDatabaseRefPath.fromJson(JSONObject(json.getJSONArray("database_ref_paths")[it].toString()))
                    }.toList(),
                    json.getString("email"),
                    json.getString("password"))
        }
    }
}