package com.sbh.background_locations.evets

import android.Manifest
import android.content.Context
import android.content.pm.PackageManager
import android.location.LocationManager
import androidx.core.content.ContextCompat
import org.json.JSONException
import org.json.JSONObject
import java.util.*

class LocationProviderChangeEvent {
    val PERMISSION_DENIED = 2
    val PERMISSION_ALWAYS = 3
    val PERMISSION_WHEN_IN_USE = 4
    private var permission = 0
    private var gpsEnabled: Boolean = false
    private var networkEnabled: Boolean = false
    private var status = 0

    constructor(context: Context) {
        this.permission = ContextCompat.checkSelfPermission(context, Manifest.permission.ACCESS_FINE_LOCATION)

        val locationManager = context.getSystemService(Context.LOCATION_SERVICE) as LocationManager
        this.gpsEnabled = locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER)
        this.networkEnabled = locationManager.isProviderEnabled(LocationManager.NETWORK_PROVIDER)

        if (this.permission == PackageManager.PERMISSION_DENIED)
            this.status = PERMISSION_DENIED
        else {
            this.status = PERMISSION_ALWAYS
//            if (Build.VERSION.SDK_INT >= 29) {
//                this.status = if (b.c(var1)) PERMISSION_ALWAYS else PERMISSION_WHEN_IN_USE
//            } else {
//                this.status = PERMISSION_ALWAYS
//            }
        }
    }

    fun isGPSEnabled(): Boolean? {
        return gpsEnabled
    }

    fun isNetworkEnabled(): Boolean? {
        return networkEnabled
    }

    fun isEnabled(): Boolean? {
        return gpsEnabled || networkEnabled
    }

    fun isPermissionGranted(): Boolean? {
        return permission == 0
    }

    fun getStatus(): Int {
        return status
    }

    fun toJson(): JSONObject? {
        val var1 = JSONObject()
        try {
            var1.put("network", networkEnabled)
            var1.put("gps", gpsEnabled)
            var1.put("enabled", isEnabled())
            var1.put("status", status)
        } catch (var3: JSONException) {
            var3.printStackTrace()
        }
        return var1
    }

    fun toMap(): Map<String, Any?>? {
        val var1 = HashMap<String, Any?>()
        var1["network"] = networkEnabled
        var1["gps"] = gpsEnabled
        var1["enabled"] = isEnabled()
        var1["status"] = status
        return var1
    }
}