package com.sbh.background_locations.models

import android.location.Location
import org.json.JSONObject

class SBHLocation() {

    var mLocation: Location? = null
//    var json: JSONObject? = null
    private var uuid: String? = null
    var timestamp: String? = null
    //    var enableTimestampMeta: Boolean = false
    var accuracy: Double? = null
    var altitude: Double? = null
    var heading: Double? = null
    var latitude: Double? = null
    var longitude: Double? = null
    var speed: Double? = null
    var event: String? = ""
    var odometer: Float? = null
    var isMoving: Boolean? = false

    constructor(location: Location) : this() {
        this.mLocation = location
        this.accuracy = location.accuracy.toDouble()
        this.altitude = location.altitude.toDouble()
        this.heading = location.bearing.toDouble()
        this.latitude = location.latitude
        this.longitude = location.longitude
        this.speed = location.speed.toDouble()
    }

    constructor(location: Location, locationMap: java.util.HashMap<String, Any>) : this() {
        this.mLocation = location
        this.accuracy = location.accuracy.toDouble()
        this.altitude = location.altitude.toDouble()
        this.heading = location.bearing.toDouble()
        this.latitude = location.latitude
        this.longitude = location.longitude
        this.speed = location.speed.toDouble()
        this.isMoving = locationMap["isMoving"] as Boolean?
        this.odometer = locationMap["odometer"] as Float?
        this.timestamp = locationMap["timestamp"] as String?
    }

    fun toMap(): HashMap<String, Any?> {
        val map = HashMap<String, Any?>()
        map["timestamp"] = timestamp
        map["accuracy"] = accuracy
        map["altitude"] = altitude
        map["heading"] = heading
        map["latitude"] = latitude
        map["longitude"] = longitude
        map["speed"] = speed
        map["event"] = event
        map["odometer"] = odometer
        map["isMoving"] = isMoving
        return map
    }
}