package com.sbh.background_locations.streams

import android.util.Log
import com.sbh.background_locations.BackgroundLocation
import com.sbh.background_locations.callbacks.SBHLocationCallback
import com.sbh.background_locations.models.SBHLocation
import io.flutter.plugin.common.EventChannel

class LocationStreamHandler : StreamHandler(), SBHLocationCallback, EventChannel.StreamHandler {
    private val TAG = "LocationStreamHandler"

    init {
        mEvent = BackgroundLocation.EVENT_LOCATION
    }

    override fun onListen(args: Any?, eventSink: EventChannel.EventSink) {
        super.onListen(args, eventSink)
        Log.d(TAG, "LOCATION STREAM IS LISTENING")
        BackgroundLocation.getInstance(mActivity).onLocation(this)
    }

    override fun onLocation(location: SBHLocation) {
        mEventSink?.success(location.toMap())
    }

    override fun onError(error: Int) {
        mEventSink?.error(error.toString(), null, null)
    }
}