package com.sbh.background_locations.streams

import android.annotation.SuppressLint
import android.util.Log
import com.sbh.background_locations.BackgroundLocation
import com.sbh.background_locations.callbacks.MotionCallback
import io.flutter.plugin.common.EventChannel

class MotionChangeStreamHandler : StreamHandler(), MotionCallback, EventChannel.StreamHandler {
    private val TAG = "MotionChangeStreamHandler"

    init {
        mEvent = BackgroundLocation.EVENT_MOTION_CHANGE
    }

    @SuppressLint("LongLogTag")
    override fun onListen(args: Any?, eventSink: EventChannel.EventSink) {
        super.onListen(args, eventSink)
        Log.d(TAG, "MOVING STREAM IS LISTENING")
        BackgroundLocation.getInstance(mActivity).onMotionChange(this)
    }

    override fun onMotionChange(isMoving: Boolean) {
        mEventSink?.success(isMoving)
    }

    override fun onError(error: Int) {
        mEventSink?.error(error.toString(), null, null)
    }
}