part of background_locations;

class FirebaseConfig {
  String appName;
  String databaseUrl;
  String apiKey;
  String applicationId;
  List<DatabaseRefPath> databaseRefPaths;
  String email;
  String password;

  FirebaseConfig({this.appName,
    @required this.databaseUrl,
    @required this.apiKey,
    @required this.applicationId,
    @required this.databaseRefPaths,
    @required this.email,
    @required this.password});

  Map toMap() {
    Map config = {};

    config['app_name'] = appName;
    config['database_url'] = databaseUrl;
    config['api_key'] = apiKey;
    config['application_id'] = applicationId;
    config['database_ref_paths'] = databaseRefPaths.map((p) => p.toMap()).toList();
    config['email'] = email;
    config['password'] = password;

    return config;
  }
}

class DatabaseRefPath {
  static const int UPDATE_METHOD_VALUE = 0;
  static const int UPDATE_METHOD_ADD = 1;

  String path;

  /// How new location should update in Firebase realtime database
  ///
  /// Default is [UPDATE_METHOD_VALUE]
  ///
  /// | Name                                 | Description                                                 |
  /// |--------------------------------------|-------------------------------------------------------------|
  /// | [UPDATE_METHOD_VALUE]                | (__DEFAULT__) Will replace the existing value               |
  /// | [UPDATE_METHOD_ADD]                  | New values will be added with auto id                       |
  ///
  int method;

  DatabaseRefPath({this.path, this.method = UPDATE_METHOD_VALUE});

  Map toMap() {
    Map config = {};
    config['path'] = path;
    config['method'] = method;
    return config;
  }
}